# Community projects

Projects built by community members:

* The [SHARK](https://github.com/nod-ai/SHARK) and
  [SRT](https://github.com/nod-ai/SRT) projects offer highly tuned performance
  and user interfaces for running a large corpus of machine learning programs.

* The [SHARK-Turbine](https://github.com/nod-ai/SHARK-Turbine) project provides
  tools for bridging between PyTorch and IREE.

* The [IREE Bare-Metal Arm Sample](https://github.com/iml130/iree-bare-metal-arm)
  shows how to build IREE with the
  [Arm GNU Toolchain](https://developer.arm.com/tools-and-software/open-source-software/developer-tools/gnu-toolchain)
  for bare-metal Arm targets using the open-source firmware libraries
  [CMSIS](https://github.com/ARM-software/CMSIS_5) and
  [libopencm3](https://github.com/libopencm3/libopencm3).

* The [IREE C++ Template](https://github.com/iml130/iree-template-cpp)
  shows one way to integrate IREE's runtime into a project with CMake.

Official repositories:

* [iree-jax](https://github.com/iree-org/iree-jax) is home to
  IREE's AOT support for [JAX](https://github.com/google/jax) programs.

* [iree-experimental](https://github.com/iree-org/iree-experimental)
  includes various samples and prototypes built with IREE.

* [iree-llvm-sandbox](https://github.com/iree-org/iree-llvm-sandbox)
  contains experimental work by the IREE team closely related to LLVM and
  MLIR, usually with the aim of contributing back to those upstream projects.
